package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.OrderAddress;
import com.izouma.awesomeadmin.service.OrderAddressService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/orderAddress")
@RequiresAuthentication
public class OrderAddressController {

    @Autowired
    private OrderAddressService orderAddressService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(OrderAddress record) {
        List<OrderAddress> pp = orderAddressService.getOrderAddressList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getOrderAddress", method = RequestMethod.GET)
    @ResponseBody
    public Result getOrderAddress(@RequestParam(required = false, value = "id") String id) {
        OrderAddress data = orderAddressService.getOrderAddressById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(OrderAddress record) {
        OrderAddress data = orderAddressService.getOrderAddress(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, OrderAddress record) {
        Map<String, Object> result = new HashMap<>();

        List<OrderAddress> pp =orderAddressService.getOrderAddressByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(OrderAddress record) {
        boolean num = orderAddressService.createOrderAddress(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateOrderAddress(OrderAddress record) {
        boolean num = orderAddressService.updateOrderAddress(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteOrderAddress(@RequestParam(required = true, value = "id") String id) {

        boolean num = orderAddressService.deleteOrderAddress(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, OrderAddress record) throws Exception {

    List<OrderAddress> orderAddresss = orderAddressService.getOrderAddressList(record);


        String sheetName = "order_address";
        String titleName = "订单收货地址数据表";
        String fileName = "订单收货地址表";
        int columnNumber = 14;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "订单ID" ,   "用户ID" ,   "收件人" ,   "电话" ,   "邮编" ,   "地址" ,   "详细地址" ,   "用户地址"  };
        String[][] dataList = new String[orderAddresss.size()][14];

        for (int i = 0; i < orderAddresss.size(); i++) {

                        dataList[i][0] = String.valueOf(orderAddresss.get(i).getId());
                        dataList[i][1] = String.valueOf(orderAddresss.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(orderAddresss.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(orderAddresss.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(orderAddresss.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(orderAddresss.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(orderAddresss.get(i).getOrderId());
                        dataList[i][7] = String.valueOf(orderAddresss.get(i).getUserId());
                        dataList[i][8] = String.valueOf(orderAddresss.get(i).getRealName());
                        dataList[i][9] = String.valueOf(orderAddresss.get(i).getTelephone());
                        dataList[i][10] = String.valueOf(orderAddresss.get(i).getPostcode());
                        dataList[i][11] = String.valueOf(orderAddresss.get(i).getAddress());
                        dataList[i][12] = String.valueOf(orderAddresss.get(i).getAddressDetail());
                        dataList[i][13] = String.valueOf(orderAddresss.get(i).getUserAddressId());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

